//+------------------------------------------------------------------+
//|                                                            Otkat |
//|                                            Copyright  2009-2012 |
//|                                                www.EarnForex.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009-2012, EarnForex.com"
#property link      "http://www.earnforex.com"

extern double TakeProfit = 8;
extern double StopLoss = 51;
extern double Lots = 1.0;
extern double Otkat = 20;
extern double KoridorOC = 18;
extern double KoridorOt = 3;
//Set it to your MT4 server's timezone relative to GMT
//E.g. set it to 7 if your server is in GMT+7 timezone
extern int Server_GMT_Difference = 1;
extern bool ECN_Mode = false; // In ECN mode, SL and TP aren't applied on OrderSend() but are added later with OrderModify()

double Poin;

int HourToCheck;
int HourToOpen = 0;

int init()
{
   //Checking for unconvetional Point digits number
   if (Point == 0.00001) Poin = 0.0001; //5 digits
   else if (Point == 0.001) Poin = 0.01; //3 digits
   else Poin = Point; //Normal
   
   if ((22 + Server_GMT_Difference) > 23)
   {
      HourToCheck = 22 + Server_GMT_Difference - 24;
   }
   else
   {
      HourToCheck = 22 + Server_GMT_Difference;
   }
   if (Server_GMT_Difference < 0) HourToOpen = 24 + Server_GMT_Difference;
   else HourToOpen = Server_GMT_Difference;
   return(0);
}

//+------------------------------------------------------------------+
//|   !                                              |
//+------------------------------------------------------------------+
int start()
  {
   int cnt, ticket, total;
   double OpCl=0,ClOp=0,ClLo=0,HiCl=0,OpD=0;
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<8)
     {
      Print("TakeProfit less than 8");
      return(0);  // check TakeProfit
     }

   total=OrdersTotal();
   //  
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
              if(total>0 && Hour()==HourToCheck && Minute()>45)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
           }
         else // go to short position
           {
            // should it be closed?
            if(total>0 && Hour()==HourToCheck && Minute()>45)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
           }
        }
     } //   
   if(total<1) 
     {
     RefreshRates();
     OpCl=Open[24]-Close[1];
     ClOp=Close[1]-Open[24];
     ClLo=Close[1]-Low[Lowest(NULL,60,MODE_LOW,24,0)];
     HiCl=High[Highest(NULL,60,MODE_HIGH,24,0)]-Close[1];
     OpD=Open[0];
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      double SL = 0, TP = 0, ecnSL = 0, ecnTP = 0;
      if (!ECN_Mode)
      {
         SL = OpD-StopLoss*Poin;
         TP = OpD+(TakeProfit+3)*Poin;
      }
      else
      {
         ecnSL = OpD-StopLoss*Poin;
         ecnTP = OpD+(TakeProfit+3)*Poin;
      }
      if(Hour()==HourToOpen && Minute()<=3 && DayOfWeek() > 1 && DayOfWeek() < 5 && OpCl>KoridorOC*Poin && ClLo<(Otkat-KoridorOt)*Poin)
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,OpD,10,SL,TP,"73_Sys",16384,0,LawnGreen);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            {
               Print("BUY order opened : ",OrderOpenPrice());
               if (ECN_Mode) OrderModify(OrderTicket(), OrderOpenPrice(), ecnSL, ecnTP, 0);
            }
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0);
      }
      if(Hour()==HourToOpen && Minute()<=3 && DayOfWeek() > 1 && DayOfWeek() < 5 && ClOp>KoridorOC*Poin && HiCl>(Otkat+KoridorOt)*Poin)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,OpD,10,SL,TP,"73_Sys",16384,0,LawnGreen);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            {
               Print("BUY order opened : ",OrderOpenPrice());
               if (ECN_Mode) OrderModify(OrderTicket(), OrderOpenPrice(), ecnSL, ecnTP, 0);
            }
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if (!ECN_Mode)
      {
         SL = OpD+StopLoss*Poin;
         TP = OpD-TakeProfit*Poin;
      }
      else
      {
         ecnSL = OpD+StopLoss*Poin;
         ecnTP = OpD-TakeProfit*Poin;
      }
      if(Hour()==HourToOpen && Minute()<=3 && DayOfWeek() > 1 && DayOfWeek() < 5 && ClOp>KoridorOC*Poin && HiCl<(Otkat-KoridorOt)*Poin)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,OpD,10,SL,TP,"73_Sys",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            {
               Print("SELL order opened : ",OrderOpenPrice());
               if (ECN_Mode) OrderModify(OrderTicket(), OrderOpenPrice(), ecnSL, ecnTP, 0);
            }
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      if(Hour()==HourToOpen && Minute()<=3 && DayOfWeek() > 1 && DayOfWeek() < 5 && OpCl>KoridorOC*Poin && ClLo>(Otkat+KoridorOt)*Poin)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,OpD,10,SL,TP,"73_Sys",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            {
               Print("SELL order opened : ",OrderOpenPrice());
               if (ECN_Mode) OrderModify(OrderTicket(), OrderOpenPrice(), ecnSL, ecnTP, 0);
            }
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   return(0);
  }
// the end.